%% Seminář 6
%% Oběktově orientované programování
%% 
% * Cell array
% * Struktury
% * Objekty
%% Cell arrays
% |Cell array| je datový typ, kde můžeme uchovávat pod jedním názvem více hodnot, 
% obdobně jako v matici. Hlavní rozdíl je v tom, že jednotlivé elementy mohou 
% být různého datového typu. Jednotlivým elementům říkáme |cell|.
% 
% Vytváří se výčtem hodnot uzavřených ve složených závorkách.

c = {42 randi(5,[2,2]) "ahoj"}
%% 
% K jednotlivým datům přistupujeme pomocí indexů (obdobně jako u matic), které 
% píšme do složených závorek.

c{3}
%% 
% Stejně jako matice jednotlivé prvky v řádku oddělujeme mezerou nebo čárkou, 
% řádky oddělujeme středníkem. Indexujeme pomocí dvou indexů

c2 = {1 2 3; 'ahoj' ' ' 'svete'}
c2{2,1}
%% 
% Klasické indexování pomocí kulatých závorek vrátí |cell|.

c2(2,1)
%% 
% Grafické znázornění |cell array| pomocí funkce |cellplot()|.

cellplot(c2)
% Převod mezi datovými typy a |cell array|
% |cell2mat(), cell2struct(), cell2table(), mat2cell(), num2cell(), struct2cell(), 
% table2cell().|
% Prealokace paměti
% Pomocí funkce |cell()| nebo vytvořením prázného |cell array|. Následující 
% dva přístupy jsou ekvivalentní.

c3 = cell(2,5);
c4{2,5} = [];
%% 
% Nejčastěji se cell array používají pro uchovávání řetězců (ne stringů).

% vysledkem je jeden retezec (jedno pole) 
M = ['ahoj' ' ' 'svete']

% takto nefunguje
N(1) = 'ahoj';
N(2) = ' ';
N(3) = 'svete';
N
%%
% 3 retezce
M1 = {'ahoj' ' ' 'svete'}

N1{1} = 'ahoj';
N1{2} = ' ';
N1{3} = 'svete';
N1
%% 
% _Vytvořte |cell array|, které jako první položku bude obsahovat název grafu, 
% jako druhou náhodná data (vektor obsahující 20 hodnot), Vykreslete tento graf 
% spolu s názvem grafu (title)._
%% Struktury
% Struktury si můžeme představit jako pole s pojmenovanými položkami. Jedlotlivé 
% položky mohou být různého datového typu. Pro přístup k jednotlivým položkám 
% používáme operátor |.|
% 
% Pomocí něj také strukturu vytváříme. Viz následující příklad pro strukturu 
% bod.

bodA.x = 10;
bodA.y = 0;

bodA

whos bod

bodA.x
%% 
% _Poklepejte 2x na proměnnou bod ve workspace._
%% 
% Jednotlivé položky struktury mohou být také struktury. Například úsečka.

bodB.x = 10;
bodB.y = 5;

usecka.A = bodA;
usecka.B = bodB;

usecka
usecka.A
usecka.A.x
%% 
% Všechny hodnoty můžeme nastavit najednou pomocí příkazu |struct().| Jako argumenty 
% se střídají názvy a hodnoty.

bodC = struct('x', 50, 'y', 0)
%% 
% Můžeme vytvářet vektory/matice, které obsahuj struktury,

matice = [bodA bodB bodC]
matice(1)
matice(1).x
%% 
% _Vytvořte strukturu, ve které se bude uchovávat název grafu a data (náhodná 
% data o velikosti 20 hodnot). Vykreslete tento graf spolu s názvem grafu._
%% 
% Nevýhoda struktur může být to, že nové položky vytváříme pomocí tečkového 
% operátoru. Pokud bychom měli překlep v názvu položky, tak matlab nezahlásí chybu, 
% vytvoří novou položku.
% 
% Předpokládejme, že chceme bodu |bodC| nastavit souřadnici |y| na 10 a máme 
% přeplou klávesnici na českou.

bodC.z = 10

bodC
%% Objekty
% Řešením může být nepužívat struktury, ale objekty. 
% Vytvoření třídy
% class definition file -- .m název shodný s názvem třídy.
% 
% *syntaxe*:
% 
% |classdef nazev|
% 
% |% popis třídy|
% 
% |% detailní popis|
% 
% |...|
% 
% |end|
% 
% Uvnitř definujeme vlastnosti (|properties|) a metody (|methods|)
% 
% _Podívejme se na třídu |bod|, kde definujeme jen dvě vlastnosti |x| a |y|._
% Vytvoření objektu

bodD = bod;
whos bodD

% vypis objektu
bodD
%% 
% K vlastnistem přistupujeme pomocí operátoru |.|

bodD.x = 10;
bodD
%% 
% _Zkuste nastavit vlastnost, která v objektu neexistuje (bodD.z). Viz odstrašující 
% příklad u struktur._ 
% Oprávnění 
% Jednotlivým vlastnostem můžeme nastavit, zda je možné je modifikovat, zda 
% jsou skryté nebo se dynamicky mění jejich hodnota. Za |properties| napíšeme 
% typ vlastnosti. 
% 
% *syntaxe*:
% 
% |properties (_Atribut1_ = hodnota1, _Atribute_ = hodnota2,...)|
% 
% |...|
% 
% |end|
% 
% *Více o atributech vlastností:*
% 
% <https://uk.mathworks.com/help/matlab/matlab_oop/property-attributes.html 
% https://uk.mathworks.com/help/matlab/matlab_oop/property-attributes.html>
% 
% _Podívejte se na definici třídy |trida|._

t = trida;
whos t

t
%%
t.konstanta = 5
%%
t.verejna = 5
%%
t.privatni
% Metody/operace
% *syntaxe*:
% 
% |methods (_Atribut1_ = hodnota1, _Atribute_ = hodnota2,...)|
% 
% |function vystupni_argumenty = method1(obj,vstupni_argumenty)|
% 
% |...|
% 
% |end|
% 
% |end|
% |Konstruktor|
% |function obj = nazev_tridy(vstupni_argumenty)|
% 
% |obj.vlastnost1 = hodnota1;|
% 
% |...|
% 
% |end|
%% 
% _Ve třídě |trida| vytvořte konstruktor a metodu, která vypíše hodnotu vlastnosti 
% |privatni|. (Řešení je např. v definici |trida2|)._
% Vytvoření objektu a volání funkcí

t2 = trida2(10,10)

% volani funkce vypis_privatni
t2.vypis_privatni
vypis_privatni(t2)

% volani funkce prijimajici argumenty obj a h
t2.pricti(2)
pricti(t2,2)
%% 
% _Při vytváření objektu musíme respektovat počet argumentů, které konstruktor 
% očekává. V minulé hodině jsme se bavili o variadických funkcích. Upravte konstruktor 
% tak, že pokud nebude přijímat žádnou argument, nenastaví nic, pokud jeden nastaví 
% se hodnota vlastnosti |verejna| (|privatni| ma defaultni hodnotu), pokud dvě 
% pak se nastaví jak |verejna|, tak |privatni|._
%% 
% Obecně by v konstruktoru měla být i validace dat.
% 
% Stejně jako u vlastností i u metod můžeme nastavit různé atributy. *Více*:
% 
% <https://uk.mathworks.com/help/matlab/matlab_oop/method-attributes.html https://uk.mathworks.com/help/matlab/matlab_oop/method-attributes.html>
% 
% Můžeme nastavit i atributy třídy. *Více*:
% 
% <https://uk.mathworks.com/help/matlab/matlab_oop/class-attributes.html https://uk.mathworks.com/help/matlab/matlab_oop/class-attributes.html>
% 
% Kromě vlastností a metodu můžeme vytvářet i události (|events|). *Více*:
% 
% <https://uk.mathworks.com/help/matlab/matlab_oop/event-attributes.html https://uk.mathworks.com/help/matlab/matlab_oop/event-attributes.html>
%% 
% Funkce nemusíme definovat v |class definition file|. Je možné je uložit do 
% složky |@nazev_tridy| a mohou to být samostatné soubory. Ve složce |private| 
% jsou privátní metody. |class definition file| musí být také v této složce.
% 
% Podívejte se na třídu bod2.

bodE = bod2(1,2,0)
bodE.delka
%bodE.privatni
bodE.volani_privatni
% Dědičnost
% *syntaxe*:
% 
% |classdef nazev < nazev_rodice|
% 
% |...|
% 
% |end|
% 
% 
% 
% Pro vícenásobnou dědičnost
% 
% |classdef nazev < nazev_rodice1 & nazev_rodice2 & nazev_rodice3|
% 
% |...|
% 
% |end|